/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the PinterestConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PinterestConnectorFormAllOf{}

// PinterestConnectorFormAllOf struct for PinterestConnectorFormAllOf
type PinterestConnectorFormAllOf struct {
	// Fixed data types Associative array
	ReportLevel *string `json:"reportLevel,omitempty"`
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label
	Label *string `json:"label,omitempty"`
	// TikTok advertiser ID
	AdAccountId *string `json:"adAccountId,omitempty"`
	// Data range expression. Required for automation
	DateRange *string `json:"dateRange,omitempty"`
	// Metrics to be included in the result
	Column []string `json:"column,omitempty"`
	// Metrics to be included in the result
	DataLabel []string `json:"dataLabel,omitempty"`
	// ID dimension to be included in the result
	EngagementWindowDays *string `json:"engagementWindowDays,omitempty"`
	// Time dimension to be included in the result
	ViewWindowDays *string `json:"viewWindowDays,omitempty"`
	// Audience dimension to be included in the result
	ConversionReportTime *string `json:"conversionReportTime,omitempty"`
	// The report type
	Granularity *string `json:"granularity,omitempty"`
	// The data level
	ClickWindowDays *string `json:"clickWindowDays,omitempty"`
}

// NewPinterestConnectorFormAllOf instantiates a new PinterestConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPinterestConnectorFormAllOf() *PinterestConnectorFormAllOf {
	this := PinterestConnectorFormAllOf{}
	return &this
}

// NewPinterestConnectorFormAllOfWithDefaults instantiates a new PinterestConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPinterestConnectorFormAllOfWithDefaults() *PinterestConnectorFormAllOf {
	this := PinterestConnectorFormAllOf{}
	return &this
}

// GetReportLevel returns the ReportLevel field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetReportLevel() string {
	if o == nil || IsNil(o.ReportLevel) {
		var ret string
		return ret
	}
	return *o.ReportLevel
}

// GetReportLevelOk returns a tuple with the ReportLevel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetReportLevelOk() (*string, bool) {
	if o == nil || IsNil(o.ReportLevel) {
		return nil, false
	}
	return o.ReportLevel, true
}

// HasReportLevel returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasReportLevel() bool {
	if o != nil && !IsNil(o.ReportLevel) {
		return true
	}

	return false
}

// SetReportLevel gets a reference to the given string and assigns it to the ReportLevel field.
func (o *PinterestConnectorFormAllOf) SetReportLevel(v string) {
	o.ReportLevel = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *PinterestConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *PinterestConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetAdAccountId returns the AdAccountId field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetAdAccountId() string {
	if o == nil || IsNil(o.AdAccountId) {
		var ret string
		return ret
	}
	return *o.AdAccountId
}

// GetAdAccountIdOk returns a tuple with the AdAccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetAdAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AdAccountId) {
		return nil, false
	}
	return o.AdAccountId, true
}

// HasAdAccountId returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasAdAccountId() bool {
	if o != nil && !IsNil(o.AdAccountId) {
		return true
	}

	return false
}

// SetAdAccountId gets a reference to the given string and assigns it to the AdAccountId field.
func (o *PinterestConnectorFormAllOf) SetAdAccountId(v string) {
	o.AdAccountId = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *PinterestConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetColumn() []string {
	if o == nil || IsNil(o.Column) {
		var ret []string
		return ret
	}
	return o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetColumnOk() ([]string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given []string and assigns it to the Column field.
func (o *PinterestConnectorFormAllOf) SetColumn(v []string) {
	o.Column = v
}

// GetDataLabel returns the DataLabel field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetDataLabel() []string {
	if o == nil || IsNil(o.DataLabel) {
		var ret []string
		return ret
	}
	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetDataLabelOk() ([]string, bool) {
	if o == nil || IsNil(o.DataLabel) {
		return nil, false
	}
	return o.DataLabel, true
}

// HasDataLabel returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasDataLabel() bool {
	if o != nil && !IsNil(o.DataLabel) {
		return true
	}

	return false
}

// SetDataLabel gets a reference to the given []string and assigns it to the DataLabel field.
func (o *PinterestConnectorFormAllOf) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetEngagementWindowDays returns the EngagementWindowDays field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetEngagementWindowDays() string {
	if o == nil || IsNil(o.EngagementWindowDays) {
		var ret string
		return ret
	}
	return *o.EngagementWindowDays
}

// GetEngagementWindowDaysOk returns a tuple with the EngagementWindowDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetEngagementWindowDaysOk() (*string, bool) {
	if o == nil || IsNil(o.EngagementWindowDays) {
		return nil, false
	}
	return o.EngagementWindowDays, true
}

// HasEngagementWindowDays returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasEngagementWindowDays() bool {
	if o != nil && !IsNil(o.EngagementWindowDays) {
		return true
	}

	return false
}

// SetEngagementWindowDays gets a reference to the given string and assigns it to the EngagementWindowDays field.
func (o *PinterestConnectorFormAllOf) SetEngagementWindowDays(v string) {
	o.EngagementWindowDays = &v
}

// GetViewWindowDays returns the ViewWindowDays field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetViewWindowDays() string {
	if o == nil || IsNil(o.ViewWindowDays) {
		var ret string
		return ret
	}
	return *o.ViewWindowDays
}

// GetViewWindowDaysOk returns a tuple with the ViewWindowDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetViewWindowDaysOk() (*string, bool) {
	if o == nil || IsNil(o.ViewWindowDays) {
		return nil, false
	}
	return o.ViewWindowDays, true
}

// HasViewWindowDays returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasViewWindowDays() bool {
	if o != nil && !IsNil(o.ViewWindowDays) {
		return true
	}

	return false
}

// SetViewWindowDays gets a reference to the given string and assigns it to the ViewWindowDays field.
func (o *PinterestConnectorFormAllOf) SetViewWindowDays(v string) {
	o.ViewWindowDays = &v
}

// GetConversionReportTime returns the ConversionReportTime field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetConversionReportTime() string {
	if o == nil || IsNil(o.ConversionReportTime) {
		var ret string
		return ret
	}
	return *o.ConversionReportTime
}

// GetConversionReportTimeOk returns a tuple with the ConversionReportTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetConversionReportTimeOk() (*string, bool) {
	if o == nil || IsNil(o.ConversionReportTime) {
		return nil, false
	}
	return o.ConversionReportTime, true
}

// HasConversionReportTime returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasConversionReportTime() bool {
	if o != nil && !IsNil(o.ConversionReportTime) {
		return true
	}

	return false
}

// SetConversionReportTime gets a reference to the given string and assigns it to the ConversionReportTime field.
func (o *PinterestConnectorFormAllOf) SetConversionReportTime(v string) {
	o.ConversionReportTime = &v
}

// GetGranularity returns the Granularity field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetGranularity() string {
	if o == nil || IsNil(o.Granularity) {
		var ret string
		return ret
	}
	return *o.Granularity
}

// GetGranularityOk returns a tuple with the Granularity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetGranularityOk() (*string, bool) {
	if o == nil || IsNil(o.Granularity) {
		return nil, false
	}
	return o.Granularity, true
}

// HasGranularity returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasGranularity() bool {
	if o != nil && !IsNil(o.Granularity) {
		return true
	}

	return false
}

// SetGranularity gets a reference to the given string and assigns it to the Granularity field.
func (o *PinterestConnectorFormAllOf) SetGranularity(v string) {
	o.Granularity = &v
}

// GetClickWindowDays returns the ClickWindowDays field value if set, zero value otherwise.
func (o *PinterestConnectorFormAllOf) GetClickWindowDays() string {
	if o == nil || IsNil(o.ClickWindowDays) {
		var ret string
		return ret
	}
	return *o.ClickWindowDays
}

// GetClickWindowDaysOk returns a tuple with the ClickWindowDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestConnectorFormAllOf) GetClickWindowDaysOk() (*string, bool) {
	if o == nil || IsNil(o.ClickWindowDays) {
		return nil, false
	}
	return o.ClickWindowDays, true
}

// HasClickWindowDays returns a boolean if a field has been set.
func (o *PinterestConnectorFormAllOf) HasClickWindowDays() bool {
	if o != nil && !IsNil(o.ClickWindowDays) {
		return true
	}

	return false
}

// SetClickWindowDays gets a reference to the given string and assigns it to the ClickWindowDays field.
func (o *PinterestConnectorFormAllOf) SetClickWindowDays(v string) {
	o.ClickWindowDays = &v
}

func (o PinterestConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PinterestConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportLevel) {
		toSerialize["reportLevel"] = o.ReportLevel
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.AdAccountId) {
		toSerialize["adAccountId"] = o.AdAccountId
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.DataLabel) {
		toSerialize["dataLabel"] = o.DataLabel
	}
	if !IsNil(o.EngagementWindowDays) {
		toSerialize["engagementWindowDays"] = o.EngagementWindowDays
	}
	if !IsNil(o.ViewWindowDays) {
		toSerialize["viewWindowDays"] = o.ViewWindowDays
	}
	if !IsNil(o.ConversionReportTime) {
		toSerialize["conversionReportTime"] = o.ConversionReportTime
	}
	if !IsNil(o.Granularity) {
		toSerialize["granularity"] = o.Granularity
	}
	if !IsNil(o.ClickWindowDays) {
		toSerialize["clickWindowDays"] = o.ClickWindowDays
	}
	return toSerialize, nil
}

type NullablePinterestConnectorFormAllOf struct {
	value *PinterestConnectorFormAllOf
	isSet bool
}

func (v NullablePinterestConnectorFormAllOf) Get() *PinterestConnectorFormAllOf {
	return v.value
}

func (v *NullablePinterestConnectorFormAllOf) Set(val *PinterestConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullablePinterestConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullablePinterestConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePinterestConnectorFormAllOf(val *PinterestConnectorFormAllOf) *NullablePinterestConnectorFormAllOf {
	return &NullablePinterestConnectorFormAllOf{value: val, isSet: true}
}

func (v NullablePinterestConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePinterestConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
